#!/usr/bin/perl

use Mail::SRS;
use strict;
use English;

my $fwdomain;
my $old_address;
if($ARGV[0] =~ /(.*):([^:]*)/) {
  $old_address=$1;
  $fwdomain=$2;
} else {
  $old_address=$ARGV[0];
}

if(!defined $fwdomain) {
  open(SRSDOMAIN, "</etc/mail/srsDomain") ||
    die "Could not open /etc/mail/srsDomain ($ERRNO)\n";
  $fwdomain=<SRSDOMAIN>;
  chomp($fwdomain);
  close(SRSDOMAIN);
}

open(SRSSECRET, "</etc/mail/srsSecret") ||
	die "Could not open /etc/mail/srsSecret ($ERRNO)\n";
my $secret=<SRSSECRET>;
chomp($secret);
close(SRSSECRET);

# No funny business in our output, please

close (STDERR);


my ($new_address, $use_address);
my $srs = new Mail::SRS (Secret => $secret, MaxAge => 8, HashLength => 8);

# Our original envelope-from may look funny on entry
# of this Ruleset:
#
#     admin<@asarian-host.net.>
#
# We need to preprocess it some:

   ($use_address = $old_address) =~ s/[<>]//g;
    $use_address =~ s/\.$//g;

# Ok, first check whether we already have a signed SRS address;
# if so, just return the old address: we do not want to double-sign
# by accident!
#
# Else, gimme a valid SRS signed address, munge it back the way
# sendmail wants it at this point; or just return the old address,
# in case nothing went.

if (eval {$new_address = $srs -> reverse ($use_address)}) {
    print "$old_address\n";
} elsif (eval {$new_address = $srs -> forward ($use_address, $fwdomain)}) {
    $new_address .= '.>';
    $new_address =~ s/\@/<@/;
    print "$new_address\n";
} else {
    print "$old_address\n";
}

exit 0;
