#!/usr/bin/perl

use Mail::SRS;
use strict;
use English;

my $fwdomain;
my $old_address;
if($ARGV[0] =~ /(.*):([^:]*)/) {
  $old_address=$1;
  $fwdomain=$2;
} else {
  $old_address=$ARGV[0];
}

if(!defined $fwdomain) {
  open(SRSDOMAIN, "</etc/mail/srsDomain") ||
    die "Could not open /etc/mail/srsDomain ($ERRNO)\n";
  $fwdomain=<SRSDOMAIN>;
  chomp($fwdomain);
  close(SRSDOMAIN);
}

open(SRSSECRET, "</etc/mail/srsSecret") ||
        die "Could not open /etc/mail/srsDomain ($ERRNO)\n";
my $secret=<SRSSECRET>;
chomp($secret);
close(SRSSECRET);


# No funny business in our output, please

close (STDERR);

my $use_address;
my $srs = new Mail::SRS (Secret => $secret, MaxAge => 8, HashLength => 8);

# Munge ParseLocal recipient in the same manner as required
# in EnvFromSMTP.

   ($use_address = $old_address) =~ s/[<>]//g;
    $use_address =~ s/\.$//g;

# Just try and reverse the address. If we succeed, return this
# new address; else, return the old address (quoted if it was
# a piped alias).

if ($use_address =~ /^SRS[01][+-=]/) {
    $use_address = $_ while (eval {$_ = $srs -> reverse ($use_address)});
    $use_address .= '.>';
    $use_address =~ s/\@/<@/;
    print "$use_address\n";
} elsif ($use_address =~ /^\|/) {
    print "\"$old_address\"\n";
} else {
    print "$old_address\n";
}

exit 0;
